// Options Dialog for Kerb's T2 Scripts
//
// (c) 2002 David Gausebeck
// gausebec@paypal.com

//*****************************************************************************
// MAIN OPTIONS DIALOG
//*****************************************************************************

new GuiControl(kScriptOptions) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "400 259";
	visible = "1";
	pane = "General";

	//--- save button ----------------------------------------------------------
	new ShellBitmapButton() {
		profile = "ShellButtonProfile";
		position = "0 210";
		extent = "82 38";
		visible = "1";
		command = "kScriptSavePrefs();";
		text = "SAVE";
	};

	//--- tab buttons ----------------------------------------------------------
	new ShellTabButton(KSO_GeneralTab) {
		profile = "ShellTabProfile";
		position = "0 15";
		extent = "108 38";
		visible = "1";
		command = "kScriptOptions.setPane(General);";
		text = "GENERAL";
	};
	new ShellTabButton(KSO_ZoomTab) {
		profile = "ShellTabProfile";
		position = "0 45";
		extent = "108 38";
		visible = "1";
		command = "kScriptOptions.setPane(Zoom);";
		text = "ZOOM";
	};
	new ShellTabButton(KSO_ControlsTab) {
		profile = "ShellTabProfile";
		position = "0 75";
		extent = "108 38";
		visible = "1";
		command = "kScriptOptions.setPane(Controls);";
		text = "CONTROLS";
	};

	//--- tab frame ------------------------------------------------------------
	new ShellTabFrame() {
		profile = "ShellTabFrameProfile";
		position = "108 0";
		extent = "282 259";
		visible = "1";
		isVertical = "1";
	};
	
	//--- general pane ---------------------------------------------------------
	new ShellFieldCtrl(KSO_GeneralPane) {
		profile = "ShellFieldProfile";
		position = "119 11";
		extent = "271 237";
		visible = "0";

		// range reticles
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 5";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::rangeReticles";
			text = "MORTAR / GRENADE RANGE RETICLES";
		};
		new GuiMLTextCtrl(KSO_rangeReticlesHelp) {
			profile = "ShellAltTextProfile";
			position = "232 9";
			extent = "30 15";
			visible = "1";
		};

		// joystick vehicle control
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 30";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::vehicleJoy";
			text = "JOYSTICK VEHICLE CONTROL";
		};
		new GuiMLTextCtrl(KSO_vehicleJoyHelp) {
			profile = "ShellAltTextProfile";
			position = "232 34";
			extent = "30 15";
			visible = "1";
		};

		// max range grenades
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 55";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::maxThrow";
			text = "THROW GRENADES AT MAX RANGE";
		};
		new GuiMLTextCtrl(KSO_maxThrowHelp) {
			profile = "ShellAltTextProfile";
			position = "232 59";
			extent = "30 15";
			visible = "1";
		};

		// jumpjet
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 80";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::jumpJet";
			text = "AUTO-JUMP BEFORE JET PACK";
		};
		new GuiMLTextCtrl(KSO_jumpJetHelp) {
			profile = "ShellAltTextProfile";
			position = "232 84";
			extent = "30 15";
			visible = "1";
		};

		// pilot bomb sight
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 105";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::pilotBombSight";
			text = "BOMBER PILOT SEES BOMB TARGET";
		};
		new GuiMLTextCtrl(KSO_pilotBombSightHelp) {
			profile = "ShellAltTextProfile";
			position = "232 109";
			extent = "30 15";
			visible = "1";
		};

		// deployable indicator
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 130";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::deployableIndicator";
			text = "ALWAYS-ON DEPLOYABLE INDICATOR";
		};
		new GuiMLTextCtrl(KSO_deployableIndicatorHelp) {
			profile = "ShellAltTextProfile";
			position = "232 134";
			extent = "30 15";
			visible = "1";
		};

		// auto missile
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 155";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::autoMissile";
			text = "AUTO-FIRE MISSILE ON LOCK";
		};
		new GuiMLTextCtrl(KSO_autoMissileHelp) {
			profile = "ShellAltTextProfile";
			position = "232 159";
			extent = "30 15";
			visible = "1";
		};

		// auto flare homing
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 180";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::autoFlareHoming";
			text = "AUTO-FLARE ON INCOMING MISSILE";
		};
		new GuiMLTextCtrl(KSO_autoFlareHomingHelp) {
			profile = "ShellAltTextProfile";
			position = "232 184";
			extent = "30 15";
			visible = "1";
		};

		// auto flare locked
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 205";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::autoFlareLock";
			text = "AUTO-FLARE ON LOCK DETECTED";
		};
		new GuiMLTextCtrl(KSO_autoFlareLockHelp) {
			profile = "ShellAltTextProfile";
			position = "232 209";
			extent = "30 15";
			visible = "1";
		};
	};

	//--- zoom pane ------------------------------------------------------------
	new ShellFieldCtrl(KSO_ZoomPane) {
		profile = "ShellFieldProfile";
		position = "119 11";
		extent = "271 237";
		visible = "0";

		// zoom toggle
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 5";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::zoomToggle";
			text = "ZOOM ACTS AS TOGGLE";
		};
		new GuiMLTextCtrl(KSO_zoomToggleHelp) {
			profile = "ShellAltTextProfile";
			position = "232 9";
			extent = "30 15";
			visible = "1";
		};

		// mousewheel zoom
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 30";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::wheelZoom";
			text = "MOUSEWHEEL ZOOM CONTROL";
		};
		new GuiMLTextCtrl(KSO_wheelZoomHelp) {
			profile = "ShellAltTextProfile";
			position = "232 34";
			extent = "30 15";
			visible = "1";
		};

		// mousewheel zoom sensitivity slider
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			position = "70 60";
			extent = "50 20";
			visible = "1";
			text = "Sensitivity";
		};
		new ShellSliderCtrl(KSO_wheelZoomSens) {
			profile = "ShellSliderProfile";
			position = "120 55";
			extent = "80 20";
			visible = "1";
			variable = "value";
			altCommand = "KSO_wheelZoomSensText.setValue($kPref::wheelZoomSens = mFloatLength(KSO_wheelZoomSens.value,1));";
			range = "1.1 4.0";
			ticks = "9999";
			usePlusMinus = "0";
		};
		new GuiTextCtrl(KSO_wheelZoomSensText) {
			profile = "GuiDefaultProfile";
			position = "202 60";
			extent = "30 20";
			visible = "1";
		};

		// default zoom
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			position = "5 80";
			extent = "220 20";
			visible = "1";
			variable = "$kPref::useDefaultZoomFOV";
			text = "ALWAYS START AT DEFAULT ZOOM";
		};
		new GuiMLTextCtrl(KSO_defaultZoomHelp) {
			profile = "ShellAltTextProfile";
			position = "232 84";
			extent = "30 15";
			visible = "1";
		};

		// default zoom fov slider
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			position = "30 110";
			extent = "90 20";
			visible = "1";
			text = "Default Zoom FOV";
		};
		new ShellSliderCtrl(KSO_defZoomFOV) {
			profile = "ShellSliderProfile";
			position = "120 105";
			extent = "80 20";
			visible = "1";
			variable = "value";
			altCommand = "KSO_defZoomFOVText.setValue($kPref::defaultZoomFOV = mFloatLength(KSO_defZoomFOV.value,0));";
			range = "5 50";
			ticks = "9999";
			usePlusMinus = "0";
		};
		new GuiTextCtrl(KSO_defZoomFOVText) {
			profile = "GuiDefaultProfile";
			position = "202 110";
			extent = "30 20";
			visible = "1";
		};

		// unzoomed fov slider
		new GuiMLTextCtrl(KSO_unzoomedFOVLabel) {
			profile = "ShellAltTextProfile";
			position = "15 159";
			extent = "120 20";
			visible = "1";
		};
		new ShellSliderCtrl(KSO_unzoomedFOV) {
			profile = "ShellSliderProfile";
			position = "120 155";
			extent = "80 20";
			visible = "1";
			variable = "value";
			command =  "if(!$ZoomON) setFOV($pref::player::defaultFOV);";
			altCommand = "KSO_unzoomedFOVText.setValue($pref::player::defaultFOV = mFloatLength(KSO_unzoomedFOV.value,0));";
			range = "70 120";
			ticks = "9999";
			usePlusMinus = "0";
		};
		new GuiTextCtrl(KSO_unzoomedFOVText) {
			profile = "GuiDefaultProfile";
			position = "202 160";
			extent = "30 20";
			visible = "1";
		};
		new GuiMLTextCtrl(KSO_unzoomedFOVHelp) {
			profile = "ShellAltTextProfile";
			position = "232 159";
			extent = "30 15";
			visible = "1";
		};
	};

	//--- controls pane --------------------------------------------------------
	new ShellFieldCtrl(KSO_ControlsPane) {
		profile = "ShellFieldProfile";
		position = "119 11";
		extent = "271 237";
		visible = "0";

		// title
		new GuiMLTextCtrl(KSO_vehicleControlsLabel) {
			profile = "ShellAltTextProfile";
			position = "10 7";
			extent = "200 20";
			visible = "1";
		};
		new GuiMLTextCtrl(KSO_vehicleControlsHelp) {
			profile = "ShellAltTextProfile";
			position = "232 7";
			extent = "30 15";
			visible = "1";
		};

		// control list
		new ShellScrollCtrl() {
			profile = "NewScrollCtrlProfile";
			position = "0 27";
			extent = "271 210";
			visible = "1";
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			childMargin = "0 2";

			new GuiScrollContentCtrl() {
				profile = "GuiDefaultProfile";
				position = "0 0";
				visible = "1";

				new ShellTextList(KSO_vehicleControls) {
					profile = "ShellTextArrayProfile";
					position = "0 0";
					visible = "1";
					altCommand = "KSO_vehicleControls.doRemap();";
					columns = "2 150";
				};
			};
		};
	};
};

//-----------------------------------------------------------------------------

KSO_unzoomedFOVLabel.setText("<color:2EFDD0>UNZOOMED FOV");
KSO_vehicleControlsLabel.setText("<color:2EFDD0>VEHICLE CONTROL OVERRIDES");

KSO_rangeReticlesHelp.setText("<a:foo>Help</a>");
function KSO_rangeReticlesHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Displays full-screen reticles with range markings whenever you use a " @
	"Mortar or Grenade Launcher.  The reticles automatically re-scale " @
	"whenever you change resolution or zoom level.");
}

KSO_vehicleJoyHelp.setText("<a:foo>Help</a>");
function KSO_vehicleJoyHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Enables joystick vehicle control.  When you enter a vehicle, your " @
	"joystick is rebound to control it flight-sim style, and your mouse " @
	"is set to FreeLook (only works when not turning).");
}

KSO_maxThrowHelp.setText("<a:foo>Help</a>");
function KSO_maxThrowHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Alters your \"Throw Grenade\" key so that grenades are always thrown " @
	"at maximum range.");
}

KSO_jumpJetHelp.setText("<a:foo>Help</a>");
function KSO_jumpJetHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Alters your \"Jet Pack\" key so that it always jumps right as you " @
	"start to jet (except when piloting a vehicle).");
}

KSO_pilotBombSightHelp.setText("<a:foo>Help</a>");
function KSO_pilotBombSightHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Displays the red \"bombs will land here\" target when you are a Bomber " @
	"pilot.");
}

KSO_deployableIndicatorHelp.setText("<a:foo>Help</a>");
function KSO_deployableIndicatorHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Displays the red/green \"can deploy here\" indicator whenever you're " @
	"carrying a deployable pack, instead of only when you're holding down " @
	"the \"Use Pack\" key.");
}

KSO_autoMissileHelp.setText("<a:foo>Help</a>");
function KSO_autoMissileHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Automatically fires missiles whenever you're using a missile launcher " @
	"and acquire a target lock.");
}

KSO_autoFlareHomingHelp.setText("<a:foo>Help</a>");
function KSO_autoFlareHomingHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Automatically throws a flare grenade (if available) whenever a missile " @
	"is in flight seeking you.");
}

KSO_autoFlareLockHelp.setText("<a:foo>Help</a>");
function KSO_autoFlareLockHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Automatically throws a flare grenade (if available) whenever an enemy " @
	"acquires a missile lock on you.");
}

KSO_zoomToggleHelp.setText("<a:foo>Help</a>");
function KSO_zoomToggleHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Alters your \"Zoom\" key so that it zooms when you press it and then " @
	"doesn't unzoom until you press it again.  The default behavior is to " @
	"unzoom when you release the key.");
}

KSO_wheelZoomHelp.setText("<a:foo>Help</a>");
function KSO_wheelZoomHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Sets your mousewheel to control zoom level whenever you are zoomed in.  " @
	"Your normal mousewheel function is restored when you zoom out.");
}

KSO_defaultZoomHelp.setText("<a:foo>Help</a>");
function KSO_defaultZoomHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Always sets you to a particular zoom level when you zoom in.  The " @
	"default behavior is to return to whatever zoom level you were last " @
	"using.");
}

KSO_unzoomedFOVHelp.setText("<a:foo>Help</a>");
function KSO_unzoomedFOVHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Changes your unzoomed field of view (FOV).  120 is the maximum " @
	"allowed by the game.");
}

KSO_vehicleControlsHelp.setText("<a:foo>Help</a>");
function KSO_vehicleControlsHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Any controls you set here will override your normal controls whenever " @
	"you're piloting a vehicle.  Note that you must have your joystick " @
	"enabled in order to map joystick buttons.");
}

//*****************************************************************************
// REMAP-KEY POPUP DIALOG
//*****************************************************************************

new GuiControl(kScriptOptionsRemapDlg) {
	profile = "DlgBackProfile";
	position = "0 0";
	extent = "640 480";
	visible = "1";
	hideCursor = "1";

	new ShellPaneCtrl(KSO_remapFrame) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "71 172";
		extent = "498 126";
		visible = "1";

		new GuiMLTextCtrl(KSO_remapText) {
			profile = "ShellMediumTextProfile";
			position = "49 47";
			extent = "400 18";
			visible = "1";
			lineSpacing = "2";
		};

		new GuiInputCtrl(KSO_remapInputCtrl) {
			profile = "GuiInputCtrlProfile";
			position = "0 0";
			visible = "1";
		};
	};
};

//-----------------------------------------------------------------------------

KSO_remapText.setText(
	"<just:center>Press a key or button to assign it to this action" NL "or " @
	"Esc to cancel...");
